package test.strickling.usbcamera;



/*	 Copyright 2012 by W. Strickling & Ashraf <code@awesomeash.com>
 * 
 *  This file is a Test routine of PTP Android Camera Control (PACC).
 *  
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or 
 *  (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.

 Version history:  
   
1.0 02.09.2012 first Beta release  
   
   
   
   
   
   
   
 *  
 *  
 *  
 */


import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Vector;

import android.app.Activity;
import android.content.Intent;
import android.content.pm.ActivityInfo;
import android.os.Bundle;
import android.os.Environment;
import android.os.Handler;
import android.os.Message;

import com.android.ptplib.BaselineInitiator;
import com.android.ptplib.Command;
import com.android.ptplib.Container;
import com.android.ptplib.Data;
import com.android.ptplib.DeviceInfo;
import com.android.ptplib.DevicePropDesc;
import com.android.ptplib.NameFactory;
import com.android.ptplib.PTPException;
import com.android.ptplib.Response;
import com.android.ptplib.CameraManager;
import com.android.ptplib.eos.EosInitiator;
import com.android.ptplib.nikon.NikonEventConstants;
import com.android.ptplib.nikon.NikonInitiator;
import test.strickling.usbcamera.R;

import android.hardware.usb.UsbDevice;
import android.util.Log;
import android.view.View;
import android.view.WindowManager;
import android.widget.EditText;
import android.widget.TextView;

public class USBCameraTest extends Activity {


	public  static final String TAG = "USBCameraTest";
	public  static final String LOGFILE_NAME = Environment.getExternalStorageDirectory().getPath() +"/USBCameraLog.txt";
	

	public Thread thread;


//	private UsbManager mUsbManager;
//	PendingIntent mPermissionIntent;

	public static  CameraManager cm;
//	public static  BaselineInitiator cm.bi;  // must be static to avoid multiple instances on same device
//	public  static boolean initDeviceRunning = false;

	static final int 	MSG_SHOW_TV2 	= 2;
	static final int 	MSG_SHOW_TV3 	= 3;
	static final int 	MSG_SHOW_TV4 	= 4;
	static final int 	MSG_SHOW_TV5 	= 5;
	static final int 	MSG_SHOW_TV6 	= 6;
	static final String THREAD_SHUTTER 	= "THREAD_SHUTTER";
	static final String THREAD_BULB 	= "THREAD_BULB";
	static final String THREAD_SPD 		= "THREAD_SPD";
	static final String THREAD_ISO 		= "THREAD_ISO";
	static final String THREAD_AP 		= "THREAD_AP";
	static final String THREAD_EXP 		= "THREAD_EXP";
	static final String THREAD_QUAL 	= "THREAD_QUAL";

	public static String permissionRequested = "";

//	private NameFactory factory = new NameFactory();


//	Button button1, button2, button3, button4;
	TextView tv1, tv2, tv3, tv4, tv5, tv6, infoText;
	EditText editText1;


	/** Called when the activity is first created. */
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		Log.d(TAG, "*** onCreate, isTaskRoot: " +isTaskRoot());
		if (!isTaskRoot()) { // http://stackoverflow.com/questions/4341600/how-to-prevent-multiple-instances-of-an-activity-when-it-is-launched-with-differ
//		    final Intent intent = getIntent();
//		    final String intentAction = intent.getAction(); 
//			Log.d(TAG, "### Not Task root, intent: " +intentAction);
	        Log.d(TAG, "### Main Activity is not the root.  Finishing Activity instead of launching.");
	        finish();
	        return;       
		};
		
		setContentView(R.layout.main);
//		mUsbManager = (UsbManager)getSystemService(Context.USB_SERVICE);

		tv1 = (TextView) findViewById(R.id.tv1);
		tv2 = (TextView) findViewById(R.id.tv2);
		tv3 = (TextView) findViewById(R.id.tv3);
		tv4 = (TextView) findViewById(R.id.tv4);
		tv5 = (TextView) findViewById(R.id.tv5);
		tv6 = (TextView) findViewById(R.id.tv6);
		infoText = (TextView) findViewById(R.id.infoText);
		editText1 = (EditText) findViewById(R.id.editText1);
		
		cm = new CameraManager(this, myHandler);//, mUsbReceiver);
		tv1.setText("No Device connected");
		setTitle(getString(R.string.app_name) + " - no connection");

		// Remove Keyboard
		this.getWindow().setSoftInputMode(WindowManager.LayoutParams.SOFT_INPUT_STATE_ALWAYS_HIDDEN);
		
	}

	 public void onRestart (){
		 super.onRestart();   
		 Log.d(TAG, "***  onRestart, isTaskRoot: " +isTaskRoot());
		 }

	 public void onStart (){
		 super.onStart();   
		 Log.d(TAG, "***  onStart, isTaskRoot: " +isTaskRoot());
		 }

	
	@Override
	public void onResume() {
		super.onResume();
		Log.d(TAG, "***   onResume, isTaskRoot: " +isTaskRoot());
		if (cm != null) cm.requestPermission ();
//		if (permissionRequested == "") requestPermission (searchDevice ()); 
	}
	
	 public void onStop (){
		 super.onStop();   
		 Log.d(TAG, "***  onStop, isTaskRoot: " +isTaskRoot());
		 }

	 public void onDestroy (){
		 if (!isTaskRoot()) Log.d(TAG, "*** onDestroy isTaskRoot: " +isTaskRoot());
		 if (isTaskRoot() && cm != null && cm.bi != null //&& cm.bi.device != null
				 ){
			 Log.d(TAG, "*** onDestroy, detach device, isTaskRoot: " +isTaskRoot());
			 cm.detachDevice ();
		 }
		 super.onDestroy();   
	 }

	
	public Response showResponse (Response response) {
		log ("  Type: " + Response.getBlockTypeName(response.getBlockType()) +" (Code: " +response.getBlockType() +")\n");   // getU16 (4)
		log ("  Name: " + response.getCodeName(response.getCode())+ ", code: 0x" +Integer.toHexString(response.getCode()) +"\n"); //getU16 (6)
		//			log ("  CodeString:" + response.getCodeString()+ "\n");
		log ("  Length: " + response.getLength()+ " bytes\n");  //getS32 (0)
		log ("  String: " + response.toString());
		return response;
	}




	private void dispDevice(UsbDevice device) {
		tv2.setText("N: "+device.getDeviceName() + "\nVID: "+ device.getVendorId());
		if (device.getVendorId() == EosInitiator.CANON_VID) tv2.append(" (Canon)");
		if (device.getVendorId() == NikonInitiator.NIKON_VID) tv2.append(" (Nikon)");
		tv2.append(", PID: " +device.getProductId());
		tv3.setText("Prot: "+device.getDeviceProtocol() +", Cl: "+device.getDeviceClass()+", Subcl: "+device.getDeviceSubclass());
		tv5.setText ("");
	}



	public void clearTV ()
	{
		tv1.setText("");
		tv2.setText("");
		tv3.setText("");
		tv4.setText("");
		tv5.setText("");
		tv6.setText("");	    
	}

	 public void write(byte[] data, int length, int timeout)
	 {
	  Log.d(TAG,"Sending command");
	  cm.bi.mConnection.bulkTransfer(cm.bi.epOut, data , length , timeout);
	   
	 }
	 
	 public byte[] read(int timeout)
	 {
	  Log.d(TAG,"Reading data");
	  byte data[] = new byte[cm.bi.inMaxPS]; 
	  int lengthOfBytes = cm.bi.mConnection.bulkTransfer(cm.bi.epIn, data , cm.bi.inMaxPS , timeout);
	  
	  return data;
	  
	 }

	
	public void getPropValue(TextView tv, int value)  // for NIKON only!
	 {final int TIMEOUT = 1000;
	  
	  Command command = new Command(Command.GetDevicePropDesc, cm.bi.session, value);
	  write(command.data, command.length, TIMEOUT);    
	  byte buf[] = read(TIMEOUT);
	  
	  
	  DevicePropDesc info = new DevicePropDesc (cm.bi);
	  info.data = buf;
	  info.length = info.getLength();
	  info.parse();
	  tv.setText(info.toString());
	  
	  Response response = new Response (buf, cm.bi.inMaxPS, cm.bi);
	  tv3.append("\n"+response.toString());
	  
	  buf = read(TIMEOUT);
	  
//	  tv3.append("\n");
//	  tv3.append("GetDeviceResponse: ");
//	  hexString = new StringBuffer();
//	  for (int i=0;i<buf.length;i++) {
//	      hexString.append(Integer.toHexString(0xFF & buf[i]));
//	      }
//	  tv3.append(hexString);
//	  response = new Response (buf, cm.bi.inMaxPS, cm.bi);
//	  tv3.append("\n"+response.toString());
	  
	 }
	
	public void onClick (View v){ //TODO
		infoText.setText("");
		switch (v.getId()) {
		
		case R.id.button1: //Reset Connection
			clearTV();
			DevicePropDesc di= new DevicePropDesc(cm.bi);
			Response res;
			try {
				res = cm.bi.getDevicePropValue ((int) getNumeric ((EditText) findViewById(R.id.editText1)), di);// D3000 returns arryy like -5000, -4666, ...., 5000}
				cm.bi.showResponseCode ("  getDevicePropValue: ", res.getCode());
				tv1.setText(di.toString());
			} catch (Exception e1) {
				e1.printStackTrace();
				tv1.setText("Error - not supported");
			}
			
		break;
		
		case R.id.button2: // Device Info
			clearTV();
			if (cm.bi== null || cm.bi.info == null){
				tv2.setText ("Error, not connected");
				return;
			}
			DeviceInfo	info = cm.bi.info;
			if (info.vendorExtensionId != 0) {
				NameFactory factory = new NameFactory().updateFactory (info.vendorExtensionId);
				info.factory = factory;
			}
			tv2.setText(cm.bi.info.toString());
			break;
			
		case R.id.button3: //Release shutter
			clearTV();
			tv1.setText("Release shutter");
			if (cm.bi == null) {
				tv1.setText("Error: no Device connected!");
				return;
			}
			tv2.setText("Starting Thread");					
			thread  = new Thread (r, THREAD_SHUTTER);
			thread.start();
			break;
			
		case R.id.spdBtn:  // Exposure time
			infoText.setText("");
			tv1.setText("Exposure time pressed");
			tv2.setText("Starting thread.");
			tv5.setText("");
			if (getNumeric (editText1) <= 0) { 
				editText1.setText ("1/60");
				infoText.setText("Suitable values example (Seconds expected):\n1/60, 8, 0.001, 1/1000");
			}
			thread  = new Thread (r, THREAD_SPD);
			thread.start();
			break;
			
		case R.id.apertBtn:  // Aperture
			tv1.setText("Aperture pressed");
			tv2.setText("Starting thread.");
			tv5.setText("");
			infoText.setText("");
			if (getNumeric (editText1) <= 0) { 
				editText1.setText ("5.6");
				infoText.setText("Suitable values example (f stop number expected):\n5.6, 8, 11");
			}
			thread  = new Thread (r, THREAD_AP);
			thread.start();
			break;
			
		case R.id.ISOBtn:  // ISO
			tv1.setText("ISO pressed");
			tv2.setText("Starting thread.");
			tv5.setText("");
			infoText.setText("");
			if (getNumeric (editText1) < 0) { 
				editText1.setText ("100");
				infoText.setText("Suitable values example (ISO number expected):\nAuto, 100, 200, 1600");
			}
			thread  = new Thread (r, THREAD_ISO);
			thread.start();
			break;
			
		case R.id.expBtn:  // Exposure correction
			tv1.setText("Exposure correction pressed");
			tv2.setText("Starting thread.");
			tv5.setText("");
			infoText.setText("");
			if (getNumeric (editText1) <= 0) { 
				editText1.setText ("-1");
				infoText.setText("Suitable values example:\n-2, -1.5, -1, 0, 1, 2");
			}			
			thread  = new Thread (r, THREAD_EXP);
			thread.start();
			break;
			
		case R.id.qualBtn:  // Quality
			Log.d(TAG, "running Quality");
			infoText.setText("");
			Response resp=null;
			try {
				resp = cm.bi.setImageQuality(((EditText) (findViewById(R.id.editText1))).getText().toString(), BaselineInitiator.BUSY_TIMEOUT_MILLIS);
			} catch (PTPException e) {
				e.printStackTrace();
			}
			if (getNumeric (editText1) <= 0) { 
				editText1.setText ("mFine");
				infoText.setText("Suitable values example:\nRAW, S, MF, MFine, LNormal");
			}
			cm.bi.showResponseCode ("  setImageQuality: ", resp.getCode());	
			log(MSG_SHOW_TV5, "setImageQuality: " +resp.getResponseString());
			saveLog (cm.bi.info.model +": setImageQuality: " +resp.getResponseString());
			break;
						
		case R.id.button5: //Bulb
			infoText.setText("");
			if (!bulbRunning) tv5.setText("");
			thread  = new Thread (r, THREAD_BULB);
			thread.start();
			break;
		}
		
	}


	/** opens session, sends EOS_OC_Capture command, closes session
	 * 
	 * @param session
	 * @return
	 */
	public boolean releaseShutter (){
		Log.d(TAG, "Starting releaseShutter");
		boolean result = cm.bi.session.isActive();
		if (cm.bi.device == null) {log("NO DEVICE OPENED"); return false;}
		if (!cm.bi.isSessionActive())
			try {
				cm.bi.openSession();
			} catch (PTPException e) {
				e.printStackTrace();
				result = false;
			}
		if (cm.bi.isSessionActive()) {
			try {
				Log.d(TAG, "Start initiateCapture");
				log("Start initiateCapture\n");
        		Response resp;
				resp = cm.bi.initiateCapture(0, 0);
				cm.bi.showResponseCode ("  ReleaseShutter , len: " +resp.getLength() +",", resp.getCode());
				result = true;
			} catch (PTPException e) {
				e.printStackTrace();
				result = false;
			}
		}
		return result;
	}  //releaseShutter


	// Does not work!
	public Response setDevicePropValue (int property, int value) throws PTPException{
    	byte [] buff = new byte [24];
    	Data data = new Data (false, buff, buff.length, cm.bi);
        data.offset = 0;
        data.putHeader(buff.length, Container.BLOCK_TYPE_DATA, Command.SetDevicePropValue, 0 /*XID, dummy, overwritten*/);
    	data.put32 (0x0c);
    	data.put32 (property);
    	data.put32 (value);//data.put32 (0x64);//data.put32 (0x00010002);		        	
		return cm.bi.transact1(Command.SetDevicePropValue, data, property);
	}
	
	
	public Response getDevicePropValue (int property) throws PTPException{
		Log.d(TAG, "getDevicePropValue");
		cm.bi.transact1(Command.EosSetEventMode, null, 1);
    	byte [] buff = new byte [cm.bi.inMaxPS];
    	Data data = new Data (true, buff, buff.length, cm.bi);
        data.putHeader(buff.length, Container.BLOCK_TYPE_DATA, Command.GetDevicePropDesc, 0 /*XID, dummy, will be overwritten*/);
//		Response resp = cm.bi.transact1(Command.EosGetDeviceInfoEx, data, property); // Returns a Data chunk 0x60 bytes, List of DeviceProperties
//		Response resp = cm.bi.transact0(Command.GetDevicePropDesc, data);  // PTP Error
//		Response resp = cm.bi.transact1(Command.GetDevicePropValue, data, property); // PTP error
//		Response resp = cm.bi.transact1(Command.GetDevicePropValue, null, property); // PTP error with data, DevicePropNotSupported with data = null
		Response resp = cm.bi.transact3(Command.EosRequestDevicePropValue, data, property, 0, 0); // general Error 0x2002 with data = null
		if (resp.getCode() == Response.OK) {
			log("\n getDeviceProp oK, dataLength: " +data.getLength());
			Log.d(TAG, " getDeviceProp oK, dataLength: " +data.getLength());
			data.dump(); // Returns a Data chunk on EosGetDeviceInfoEx
			}
		else log("\n getDeviceProp " + resp.getCodeName(resp.getCode()));
		return resp;
	}
	
    @SuppressWarnings({ "finally" })
    public static double getNumeric (String s) {
    	double r = 0;
    	if (s.contains("/")) {  // resolve fractional expressions like 1/20 (returns 0.05)
    		double p1 = getNumeric (s.substring(0, s.indexOf("/")));
    		double p2 = getNumeric (s.substring(s.indexOf("/")+1));
    		if (p2 != 0) {return p1/p2;} else return p1;
    	}

    	s = s.replaceAll( "[^\\d.,+-]", " " ).trim();
    	if (s.contains(" ")) s = s.substring(0, s.indexOf(" "));
    	s = s.replace(",", ".");      // avoids problems with decimal comma (e.g. German language)
    	s = s.replace("+", "");
    	try {
    	r = Double.valueOf (s);
    	return r;
    	}
    	finally {return r;}
    }
    
    public static double getNumeric (TextView tv) {
    	return getNumeric (tv.getText().toString());
    }
	
    public boolean checkConnection (){
		if (cm.bi.device == null) {log("NO DEVICE OPENED"); return false;}
		boolean result = cm.bi.isSessionActive();
		if (!cm.bi.isSessionActive())
			try {
				cm.bi.openSession();
				result = cm.bi.isSessionActive();
			} catch (PTPException e) {
				e.printStackTrace();
				result = false;
			}
		return result;
    }

	public boolean test (){  //TODO ISO constants etc in EosEventConstants.java
		Log.d(TAG, "Starting Test");
		if (cm.bi.device == null) {log("NO DEVICE OPENED"); return false;}
		boolean result = cm.bi.isSessionActive();
		
		if (!cm.bi.isSessionActive())
			try {
				cm.bi.openSession();
			} catch (PTPException e) {
				e.printStackTrace();
				result = false;
			}
		if (cm.bi.isSessionActive()) {
	        Response resp = null;
	        
	        synchronized (cm.bi.session) {

	        	try {
//	        		resp = cm.bi.transact1(Command.EosSetRemoteMode, null, 1);
//	        		cm.bi.showResponseCode ("  EosSetRemoteMode 1: ", resp.getCode());

//	        		resp = cm.bi.setISO(getNumeric ((EditText) findViewById(R.id.editText1)));
//	        		cm.bi.showResponseCode ("  SetIso: ", resp.getCode());	

//	        		resp = cm.bi.setAperture(getNumeric ((EditText) findViewById(R.id.editText1)));
//	        		cm.bi.showResponseCode ("  SetIso: ", resp.getCode());	
	        		
//	        		resp = cm.bi.setShutterSpeed(getNumeric ((EditText) findViewById(R.id.editText1)));
//	        		cm.bi.showResponseCode ("  setShutterSpeed: ", resp.getCode());	
	        		
	        		resp = cm.bi.setExposure(getNumeric ((EditText) findViewById(R.id.editText1)));
	        		cm.bi.showResponseCode ("  setExposure: ", resp.getCode());	

//	        		resp = cm.bi.setImageQuality(((EditText) (findViewById(R.id.editText1))).getText().toString());
//	        		cm.bi.showResponseCode ("  setImageQuality: ", resp.getCode());	
	        		
//	            	byte [] buff = new byte [cm.bi.inMaxPS];
//	            	Data data = new Data (true, buff, buff.length, cm.bi);
//	                data.putHeader(buff.length, Container.BLOCK_TYPE_DATA, Command.EosSetEventMode, 0 /*XID, dummy, will be overwritten*/);
//	                resp = cm.bi.transact1(Command.EosSetEventMode, data, 1); 
//	                cm.bi.showResponseCode ("  EosSetEventMode, len: " +resp.getLength() +",", resp.getCode());
//	                Log.d(TAG, "Data: len " +data.getLength());
//	                data.dump();
	        		
//	        		resp = getDevicePropValue (Command.EOS_DPC_ShutterSpeed);
//	        		cm.bi.showResponseCode ("  getDevicePropValue, len: " +resp.getLength() +",", resp.getCode());
	        		
//	        		resp = cm.bi.transact1(Command.EosSetEventMode, null, 1);
//		        	cm.bi.showResponseCode ("  EosSetEventMode 1 , len: " +resp.getLength() +",", resp.getCode());
//
//		        	resp = SetImgQual ();
//		        	cm.bi.showResponseCode ("  Set ImgQual, len: " +resp.getLength() +",", resp.getCode());
//		        	
//	        		resp = cm.bi.transact1(Command.EosSetEventMode, null, 1);
//		        	cm.bi.showResponseCode ("  EosSetEventMode 1 , len: " +resp.getLength() +",", resp.getCode());
//		        	cm.bi.checkEvents();
		        	
		        	//	        		DevicePropDesc desc = new DevicePropDesc (cm.bi);
//	        		ret = cm.bi.getDevicePropDesc (Command.EOS_DPC_Iso, desc);
//		        	cm.bi.showResponseCode ("  getDevicePropDesc : " , ret);
		        	

//	        		resp = cm.bi.transact0(Command.EosSetUILock, null);
//		        	cm.bi.showResponseCode ("  EosSetUILock", resp.getCode());

//	        		resp = getDevicePropValue (Command.EOS_DPC_Iso);
//	        		cm.bi.showResponseCode (" Get EOS_DPC_Iso : " , ret);
//		        	cm.bi.checkEvents();
		        	
//		        	resp = cm.bi.setDevicePropValueEx (Command.EOS_DPC_Iso, EosEventConstants.EosISOSPeed100); //is working!
//		        	cm.bi.showResponseCode ("  SetIso, len: " +resp.length +",", resp.getCode());
//		        	cm.bi.checkEvents();
		        	
//		        	resp = cm.bi.setDevicePropValueEx (Command.EOS_DPC_ImageQuality, 0x00000211);
//		        	 //does not work properly, sets quality to invalid format
//		        	cm.bi.showResponseCode ("  Set EOS_DPC_ImageQuality :", resp.getCode());
//		        	cm.bi.checkEvents();
		        	
//		        	resp = cm.bi.setDevicePropValueEx (Command.EOS_DPC_ShutterSpeed, 0x38);//EosEventConstants.SHUTTER_SPEED_BULB);
//		        	cm.bi.showResponseCode ("  Set Shutter Speed:", resp.getCode());
//		        	cm.bi.checkEvents();
//		        	
//		        	resp = cm.bi.setDevicePropValueEx (Command.EOS_DPC_Aperture, EosEventConstants.EosAperture_4);//EosEventConstants.SHUTTER_SPEED_BULB);
//		        	cm.bi.showResponseCode ("  Set Aperture:", resp.getCode());
//		        	cm.bi.checkEvents();

//		        	resp = cm.bi.setDevicePropValueEx (Command.EOS_DPC_ExposureCompensation, 0xfc); // working oK
//		        	cm.bi.showResponseCode ("  Set EOS_DPC_ExposureCompensation:", resp.getCode());
//		        	cm.bi.checkEvents();
		        	
		        	
		        	
//	        		resp = setDevicePropValue (EosEventConstants.EosPropPictureStyleStandard,  0x81);
//	        		resp = setDevicePropValue (EosEventConstants.EosPropPictureStyleStandard,  0);
//		        	DevicePropDesc data = new DevicePropDesc (cm.bi); 
//		        	byte [] buff = new byte [cm.bi.epIn.getMaxPacketSize()];
//		        	Data data = new Data (true, buff, buff.length, cm.bi);
//		            data.offset = 0;
//		            data.putHeader(buff.length, Container.BLOCK_TYPE_DATA, 0, 0 /*XID, dummy, overwritten*/);
//		        	resp = cm.bi.transact0(Command.GetDevicePropDesc, null);
//		        	cm.bi.showResponseCode ("  SetDevicePropValue", resp.getCode());
//		        	cm.bi.checkEvents();
//		        	if (resp.getCode() == Response.OK) releaseShutter ();

	        		
	        		// Test Bulb
//		        	resp = cm.bi.eosBulb(100);
//		        	cm.bi.showResponseCode ("  bulb End: ", ret);
		        	
	        	} catch (PTPException e) {
	        		e.printStackTrace();
	        		Log.d(TAG, "PTP ERROR: " +e.toString());
	        	}

//	        	try {
////	        		DeviceInfo data = new DeviceInfo(cm.bi);
//	        		Data data = new DevicePropDesc (cm.bi);
//	        		Command command;
//	        		command = new Command(Command.GetDevicePropDesc, cm.bi.session);//, DevicePropDesc.ExposureTime);
//	        		resp = cm.bi.transactUnsync(command, data); //(Command.GetDevicePropValue, data, DevicePropDesc.ExposureTime).getCode();
//	        		cm.bi.showResponse (resp);
//	        		//	        	ret = cm.bi.transact1(Command.EosSetEventMode, null, 1).getCode();
//
//	        	} catch (PTPException e) {
//	        		e.printStackTrace();
//	        	}
//	        	cm.bi.showResponseCode ("  GetDevicePropDesc : ", ret);

	        	//	        try {
	        	//	        	Data data = new Data (cm.bi);
	        	//				resp = cm.bi.transact2(Command.SetDevicePropValue, null, EosEventConstants.EosPropISOSpeed, 0x58);
	        	//				 cm.bi.showResponse(resp);
	        	//			} catch (PTPException e) {
	        	//				e.printStackTrace();
	        	//			}


//	        		        DevicePropDesc desc = new DevicePropDesc (cm.bi);
//	        		        try {
//	        		        	Log.d(TAG, "getDevicePropDesc");
//	        					resp = cm.bi.transact2(Command.GetDevicePropDesc, desc, 0x0c, DevicePropDesc.ExposureTime);
//	        			        cm.bi.showResponseCode ("  DevicePropDesc  len ", resp.getCode());
//	        			        if (resp.getCode() == Response.OK) {
//	        			        	Log.d(TAG, "dumping desc");
//	        			        }
//	        				} catch (PTPException e) {
//	        					e.printStackTrace();
//	        				}

	        	// Reset remote mode
//	        	try {
//	        		resp = cm.bi.transact1(Command.EosSetRemoteMode, null, 0);
////	        		cm.bi.showResponseCode ("  Reset EosSetRemoteMode 0: ", resp.getCode());
////	        		
////		        	resp = cm.bi.transact0(Command.EosResetUILock, null);
////		        	cm.bi.showResponseCode ("  EosresetUILock", resp.getCode());
//	        	} catch (PTPException e) {}

	        }	        
		}
		return result;



	} //setISO

	
	//	 **************** run USB tasks in its own thread **********************

	static boolean bulbRunning = false;
	
	final Runnable r = new Runnable() {
		public void run() {
			Response resp = null;
			try {
				Log.d(TAG, "running thread " +thread.getName());
				if (thread.getName().equals(THREAD_SHUTTER)) { 
					releaseShutter ();
				}; 		
				if (thread.getName().equals(THREAD_SPD)) { 
					if (! checkConnection()) return;
					resp = cm.bi.setShutterSpeed(getNumeric (editText1), BaselineInitiator.BUSY_TIMEOUT_MILLIS);
					cm.bi.showResponseCode ("  setShutterSpeed: ", resp.getCode());
					log(MSG_SHOW_TV5, "setShutterSpeed: " +resp.getResponseString());
					saveLog (cm.bi.info.model +": setShutterSpeed: " +resp.getResponseString());
				}; 		
				if (thread.getName().equals(THREAD_AP)) { 
					if (! checkConnection()) return;
					resp = cm.bi.setAperture(getNumeric (editText1), BaselineInitiator.BUSY_TIMEOUT_MILLIS);
					cm.bi.showResponseCode ("  setAperture: ", resp.getCode());	
					log(MSG_SHOW_TV5, "setAperture: " +resp.getResponseString());
					saveLog (cm.bi.info.model +": setAperture: " +resp.getResponseString());
				}; 		
				if (thread.getName().equals(THREAD_ISO)) { 
					if (! checkConnection()) return;
					resp = cm.bi.setISO(getNumeric (editText1), BaselineInitiator.BUSY_TIMEOUT_MILLIS);
					cm.bi.showResponseCode ("  setISO: ", resp.getCode());
					log(MSG_SHOW_TV5, "setISO: " +resp.getResponseString());
					saveLog (cm.bi.info.model +": setISO: " +resp.getResponseString());
				}; 		
				if (thread.getName().equals(THREAD_EXP)) { 
					if (! checkConnection()) return;
					resp = cm.bi.setExposure(getNumeric (editText1), BaselineInitiator.BUSY_TIMEOUT_MILLIS);
					cm.bi.showResponseCode ("  setExposure: ", resp.getCode());	
					log(MSG_SHOW_TV5, "setExposure: " +resp.getResponseString());
					saveLog (cm.bi.info.model +": setExposure: " +resp.getResponseString());
				}; 		
				if (thread.getName().equals(THREAD_QUAL)) { 
					if (! checkConnection()) return;
					resp = cm.bi.setImageQuality((editText1).getText().toString(), BaselineInitiator.BUSY_TIMEOUT_MILLIS);
					cm.bi.showResponseCode ("  setImageQuality: ", resp.getCode());	
					log(MSG_SHOW_TV5, "setImageQuality: " +resp.getResponseString());
					saveLog (cm.bi.info.model +": setImageQuality: " +resp.getResponseString());
				}
			}catch (PTPException e) {
				e.printStackTrace();
			}
			
			if (thread.getName().equals(THREAD_BULB)) { 
				try {
					if (bulbRunning){		
						bulbRunning = false;
						log(MSG_SHOW_TV5, " stopped.");
						resp = cm.bi.stopBulb();
						cm.bi.showResponseCode ("  Bulb End", resp.getCode());
					} else {
						resp = cm.bi.startBulb();
						bulbRunning = true;
						log(MSG_SHOW_TV5, "Start Bulb ...");
					}
				} catch (PTPException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}; 		
		}
	};
	
    public void saveLog (String Line){
		try
		{   FileWriter fw = new FileWriter(new File(LOGFILE_NAME), true);
		SimpleDateFormat formatter = new SimpleDateFormat ("yyyy-MM-dd  HH:mm:ss");
		Date currentTime = new Date();
		String ZeitInfo = formatter.format(currentTime); 
			fw.write(ZeitInfo +";" +Line+"\n"); 
			fw.close();
			Log.d(TAG, "Logfile: " +ZeitInfo +";" +Line);
		} catch( IOException e )	{ e.printStackTrace();}    	
    } 


	// show messages
	void log (String s) {
		Message msg = new Message ();
		msg.what = MSG_SHOW_TV2;
		msg.obj = s;
		myHandler.sendMessage(msg);
	}

	void log (int msgWhat, String s) {
		Message msg = new Message ();
		msg.what = msgWhat;
		msg.obj = s;
		myHandler.sendMessage(msg);
	}

	Handler myHandler = new Handler() {  
		public void handleMessage(Message msg) {
//			Log.d(TAG, "Message received: " +msg.what);
			switch (msg.what ){
			case MSG_SHOW_TV2: tv2.append ((String) msg.obj);
			break;
			case MSG_SHOW_TV3: tv3.append ((String) msg.obj);
			break;
			case MSG_SHOW_TV4: tv4.append ((String) msg.obj);
			break;
			case MSG_SHOW_TV5: tv5.append ((String) msg.obj);
			break;
			case MSG_SHOW_TV6: tv6.append ((String) msg.obj);
			break;
			case CameraManager.MSG_CONNECTED: 
				setTitle(getString(R.string.app_name) + " - connected " +cm.bi.info.model);
				tv1.setText("connected to " +cm.bi.info.model);
				dispDevice (cm.bi.device);
			break;
			case CameraManager.MSG_DISCONNECTED:
				setTitle(getString(R.string.app_name) + " - disconnected");
				tv1.setText("Device detached");
			break;
			}
		}
	};
		
}
